ON_InstanceDefinition Class Reference

`#include <pcl/surface/3rdparty/opennurbs/opennurbs_instance.h>`

Inheritance diagram for ON_InstanceDefinition:

## Public Types

enum | IDEF_UPDATE_TYPE { static_def = 0, embedded_def = 1, linked_and_embedded_def = 2, linked_def = 3, force_32bit_idef_update_type = 0xFFFFFFFF }
enum | { no_idef_settings = 0, idef_name_setting = 1, idef_description_setting = 2, idef_url_setting = 4, idef_units_setting = 8, idef_source_archive_setting = 0x10, idef_userdata_setting = 0x20, all_idef_settings = 0xFFFFFFFF }

## Public Member Functions

| ON_InstanceDefinition ()
| ~ON_InstanceDefinition ()
ON_BOOL32 | IsValid (ON_TextLog *text_log=NULL) const
void | Dump (ON_TextLog &) const
ON_BOOL32 | Write (ON_BinaryArchive &binary_archive) const
ON_BOOL32 | Read (ON_BinaryArchive &binary_archive)
ON::object_type | ObjectType () const
unsigned int | SizeOf () const
int | Dimension () const
ON_BOOL32 | GetBBox (double *boxmin, double *boxmax, int bGrowBox=false) const
ON_BOOL32 | Transform (const ON_Xform &xform)
ON_UUID | ModelObjectId () const
const wchar_t * | Name () const
void | SetName (const wchar_t *name)
const wchar_t * | Description () const
void | SetDescription (const wchar_t *description)
const wchar_t * | URL () const
void | SetURL (const wchar_t *url)
const wchar_t * | URL_Tag () const
void | SetURL_Tag (const wchar_t *url_tag)
ON_UUID | Uuid () const
void | SetUuid (ON_UUID uuid)
void | SetBoundingBox (ON_BoundingBox bbox)
void | SetSourceArchive (const wchar_t *source_archive, ON_CheckSum checksum, IDEF_UPDATE_TYPE update_type)
void | DestroySourceArchive ()
const wchar_t * | SourceArchive () const
ON_CheckSum | SourceArchiveCheckSum () const
const ON_UnitSystem & | UnitSystem () const
void | SetAlternateSourceArchivePath (const wchar_t *alternate_source_archive_path, bool bRelativePath)
bool | GetAlternateSourceArchivePath (ON_wString &alternate_source_archive_path, bool &bRelativePath) const
void | SetUnitSystem (ON::unit_system us)
void | SetUnitSystem (const ON_UnitSystem &us)
bool | HasLinkedIdefLayerSettings () const
void | UpdateLinkedIdefReferenceFileLayerSettings (unsigned int layer_count, ON_Layer **layer_settings)
void | UpdateLinkedIdefParentLayerSettings (const ON_Layer *linked_idef_parent_layer)
const ON_Layer * | LinkedIdefParentLayerSettings () const
void | UpdateLinkedIdefReferenceFileLayerRuntimeId (const ON_UuidPairList &id_map)
void | UpdateLinkedIdefLayerSettings (unsigned int layer_count, const ON_Layer *const *layer_settings)
IDEF_UPDATE_TYPE | IdefUpdateType () const
Public Member Functions inherited from ON_Geometry
| ON_Geometry ()
| ON_Geometry (const ON_Geometry &)
ON_Geometry & | operator= (const ON_Geometry &)
virtual | ~ON_Geometry ()
ON_BoundingBox | BoundingBox () const
ON_BOOL32 | GetBoundingBox (ON_BoundingBox &bbox, int bGrowBox=false) const
ON_BOOL32 | GetBoundingBox (ON_3dPoint &bbox_min, ON_3dPoint &bbox_max, int bGrowBox=false) const
ON_BOOL32 | Rotate (double sin_angle, double cos_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Rotate (double rotation_angle, const ON_3dVector &rotation_axis, const ON_3dPoint &rotation_center)
ON_BOOL32 | Translate (const ON_3dVector &translation_vector)
ON_BOOL32 | Scale (double scale_factor)
virtual bool | GetTightBoundingBox (ON_BoundingBox &tight_bbox, int bGrowBox=false, const ON_Xform *xform=0) const
virtual void | ClearBoundingBox ()
virtual bool | IsDeformable () const
virtual bool | MakeDeformable ()
virtual ON_BOOL32 | SwapCoordinates (int i, int j)
virtual ON_BOOL32 | HasBrepForm () const
virtual ON_Brep * | BrepForm (ON_Brep *brep=NULL) const
virtual ON_COMPONENT_INDEX | ComponentIndex () const
virtual bool | EvaluatePoint (const class ON_ObjRef &objref, ON_3dPoint &P) const
Public Member Functions inherited from ON_Object
bool | CopyFrom (const ON_Object *src)
| ON_Object ()
| ON_Object (const ON_Object &)
ON_Object & | operator= (const ON_Object &)
virtual | ~ON_Object ()
void | EmergencyDestroy ()
virtual void | MemoryRelocate ()
ON_BOOL32 | IsKindOf (const ON_ClassId *pClassId) const
virtual ON__UINT32 | DataCRC (ON__UINT32 current_remainder) const
bool | SetUserString (const wchar_t *key, const wchar_t *string_value)
int | SetUserStrings (int count, const ON_UserString *user_strings, bool bReplace)
bool | GetUserString (const wchar_t *key, ON_wString &string_value) const
int | GetUserStrings (ON_ClassArray< ON_UserString > &user_strings) const
int | GetUserStringKeys (ON_ClassArray< ON_wString > &user_string_keys) const
int | UserStringCount () const
ON_BOOL32 | AttachUserData (ON_UserData *pUserData)
ON_BOOL32 | DetachUserData (ON_UserData *pUserData)
ON_UserData * | GetUserData (const ON_UUID &userdata_uuid) const
void | PurgeUserData ()
ON_UserData * | FirstUserData () const
void | TransformUserData (const ON_Xform &xform)
void | CopyUserData (const ON_Object &source_object)
void | MoveUserData (ON_Object &source_object)
virtual void | DestroyRuntimeCache (bool bDelete=true)

## Static Public Member Functions

static IDEF_UPDATE_TYPE | IdefUpdateType (int i)

## Public Attributes

ON_SimpleArray< ON_UUID > | m_object_uuid
ON_UUID | m_uuid
ON_wString | m_name
ON_wString | m_description
ON_wString | m_url
ON_wString | m_url_tag
ON_BoundingBox | m_bbox
ON_UnitSystem | m_us
IDEF_UPDATE_TYPE | m_idef_update_type
int | m_idef_update_depth
ON_wString | m_source_archive
bool | m_source_bRelativePath
unsigned char | m_idef_layer_style
ON_CheckSum | m_source_archive_checksum

## Detailed Description

Definition at line 27 of file opennurbs_instance.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
no_idef_settings |
idef_name_setting |
idef_description_setting |
idef_url_setting |
idef_units_setting |
idef_source_archive_setting |
idef_userdata_setting |
all_idef_settings |

Definition at line 79 of file opennurbs_instance.h.

## IDEF_UPDATE_TYPE

enum ON_InstanceDefinition::IDEF_UPDATE_TYPE

Enumerator
static_def |
embedded_def |
linked_and_embedded_def |
linked_def |
force_32bit_idef_update_type |

Definition at line 36 of file opennurbs_instance.h.

## Constructor & Destructor Documentation

## ON_InstanceDefinition()

ON_InstanceDefinition::ON_InstanceDefinition | ( |  | ) |

## ~ON_InstanceDefinition()

ON_InstanceDefinition::~ON_InstanceDefinition | ( |  | ) |

## Member Function Documentation

## Description()

const wchar_t* ON_InstanceDefinition::Description | ( |  | ) | const

## DestroySourceArchive()

void ON_InstanceDefinition::DestroySourceArchive | ( |  | ) |

## Dimension()

int ON_InstanceDefinition::Dimension | ( |  | ) | const

virtual

Implements ON_Geometry.

## Dump()

void ON_InstanceDefinition::Dump | ( | ON_TextLog & |  | ) | const

virtual

Reimplemented from ON_Object.

## GetAlternateSourceArchivePath()

bool ON_InstanceDefinition::GetAlternateSourceArchivePath | ( | ON_wString & | alternate_source_archive_path,
|  | bool & | bRelativePath
| ) |  | const

## GetBBox()

ON_BOOL32 ON_InstanceDefinition::GetBBox | ( | double * | boxmin,
|  | double * | boxmax,
|  | int | bGrowBox = `false`
| ) |  | const

virtual

Implements ON_Geometry.

## HasLinkedIdefLayerSettings()

bool ON_InstanceDefinition::HasLinkedIdefLayerSettings | ( |  | ) | const

## IdefUpdateType() [1/2]

static IDEF_UPDATE_TYPE ON_InstanceDefinition::IdefUpdateType | ( | int | i | ) |

static

## IdefUpdateType() [2/2]

IDEF_UPDATE_TYPE ON_InstanceDefinition::IdefUpdateType | ( |  | ) | const

## IsValid()

ON_BOOL32 ON_InstanceDefinition::IsValid | ( | ON_TextLog * | text_log = `NULL` | ) | const

virtual

Implements ON_Object.

## LinkedIdefParentLayerSettings()

const ON_Layer* ON_InstanceDefinition::LinkedIdefParentLayerSettings | ( |  | ) | const

## ModelObjectId()

ON_UUID ON_InstanceDefinition::ModelObjectId | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## Name()

const wchar_t* ON_InstanceDefinition::Name | ( |  | ) | const

## ObjectType()

ON::object_type ON_InstanceDefinition::ObjectType | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## Read()

ON_BOOL32 ON_InstanceDefinition::Read | ( | ON_BinaryArchive & | binary_archive | ) |

virtual

Reimplemented from ON_Object.

## SetAlternateSourceArchivePath()

void ON_InstanceDefinition::SetAlternateSourceArchivePath | ( | const wchar_t * | alternate_source_archive_path,
|  | bool | bRelativePath
| ) |  |

## SetBoundingBox()

void ON_InstanceDefinition::SetBoundingBox | ( | ON_BoundingBox | bbox | ) |

## SetDescription()

void ON_InstanceDefinition::SetDescription | ( | const wchar_t * | description | ) |

## SetName()

void ON_InstanceDefinition::SetName | ( | const wchar_t * | name | ) |

## SetSourceArchive()

void ON_InstanceDefinition::SetSourceArchive | ( | const wchar_t * | source_archive,
|  | ON_CheckSum | checksum,
|  | IDEF_UPDATE_TYPE | update_type
| ) |  |

## SetUnitSystem() [1/2]

void ON_InstanceDefinition::SetUnitSystem | ( | ON::unit_system | us | ) |

## SetUnitSystem() [2/2]

void ON_InstanceDefinition::SetUnitSystem | ( | const ON_UnitSystem & | us | ) |

## SetURL()

void ON_InstanceDefinition::SetURL | ( | const wchar_t * | url | ) |

## SetURL_Tag()

void ON_InstanceDefinition::SetURL_Tag | ( | const wchar_t * | url_tag | ) |

## SetUuid()

void ON_InstanceDefinition::SetUuid | ( | ON_UUID | uuid | ) |

## SizeOf()

unsigned int ON_InstanceDefinition::SizeOf | ( |  | ) | const

virtual

Reimplemented from ON_Object.

## SourceArchive()

const wchar_t* ON_InstanceDefinition::SourceArchive | ( |  | ) | const

## SourceArchiveCheckSum()

ON_CheckSum ON_InstanceDefinition::SourceArchiveCheckSum | ( |  | ) | const

## Transform()

ON_BOOL32 ON_InstanceDefinition::Transform | ( | const ON_Xform & | xform | ) |

virtual

Reimplemented from ON_Geometry.

## UnitSystem()

const ON_UnitSystem& ON_InstanceDefinition::UnitSystem | ( |  | ) | const

## UpdateLinkedIdefLayerSettings()

void ON_InstanceDefinition::UpdateLinkedIdefLayerSettings | ( | unsigned int | layer_count,
|  | const ON_Layer *const * | layer_settings
| ) |  |

## UpdateLinkedIdefParentLayerSettings()

void ON_InstanceDefinition::UpdateLinkedIdefParentLayerSettings | ( | const ON_Layer * | linked_idef_parent_layer | ) |

## UpdateLinkedIdefReferenceFileLayerRuntimeId()

void ON_InstanceDefinition::UpdateLinkedIdefReferenceFileLayerRuntimeId | ( | const ON_UuidPairList & | id_map | ) |

## UpdateLinkedIdefReferenceFileLayerSettings()

void ON_InstanceDefinition::UpdateLinkedIdefReferenceFileLayerSettings | ( | unsigned int | layer_count,
|  | ON_Layer ** | layer_settings
| ) |  |

## URL()

const wchar_t* ON_InstanceDefinition::URL | ( |  | ) | const

## URL_Tag()

const wchar_t* ON_InstanceDefinition::URL_Tag | ( |  | ) | const

## Uuid()

ON_UUID ON_InstanceDefinition::Uuid | ( |  | ) | const

## Write()

ON_BOOL32 ON_InstanceDefinition::Write | ( | ON_BinaryArchive & | binary_archive | ) | const

virtual

Reimplemented from ON_Object.

## Member Data Documentation

## m_bbox

ON_BoundingBox ON_InstanceDefinition::m_bbox

Definition at line 322 of file opennurbs_instance.h.

## m_description

ON_wString ON_InstanceDefinition::m_description

Definition at line 306 of file opennurbs_instance.h.

## m_idef_layer_style

unsigned char ON_InstanceDefinition::m_idef_layer_style

Definition at line 352 of file opennurbs_instance.h.

## m_idef_update_depth

int ON_InstanceDefinition::m_idef_update_depth

Definition at line 336 of file opennurbs_instance.h.

## m_idef_update_type

IDEF_UPDATE_TYPE ON_InstanceDefinition::m_idef_update_type

Definition at line 332 of file opennurbs_instance.h.

## m_name

ON_wString ON_InstanceDefinition::m_name

Definition at line 302 of file opennurbs_instance.h.

## m_object_uuid

ON_SimpleArray<ON_UUID> ON_InstanceDefinition::m_object_uuid

Definition at line 143 of file opennurbs_instance.h.

## m_source_archive

ON_wString ON_InstanceDefinition::m_source_archive

Definition at line 341 of file opennurbs_instance.h.

## m_source_archive_checksum

ON_CheckSum ON_InstanceDefinition::m_source_archive_checksum

Definition at line 368 of file opennurbs_instance.h.

## m_source_bRelativePath

bool ON_InstanceDefinition::m_source_bRelativePath

Definition at line 343 of file opennurbs_instance.h.

## m_url

ON_wString ON_InstanceDefinition::m_url

Definition at line 308 of file opennurbs_instance.h.

## m_url_tag

ON_wString ON_InstanceDefinition::m_url_tag

Definition at line 309 of file opennurbs_instance.h.

## m_us

ON_UnitSystem ON_InstanceDefinition::m_us

Definition at line 324 of file opennurbs_instance.h.

## m_uuid

ON_UUID ON_InstanceDefinition::m_uuid

Definition at line 301 of file opennurbs_instance.h.

The documentation for this class was generated from the following file:

- /build/pcl-qv3n_B/pcl-1.8.1+dfsg1/surface/include/pcl/surface/3rdparty/opennurbs/opennurbs_instance.h